<?
/******
#
# This software may be used and distributed according to the terms
# of the GNU Public License, incorporated herein by reference.
#
# See file COPYING for details of the GNU GPL.
#
#################################
WebNap Client copyright 2000
Aakash Kambuj - aakash@idearing.com
Kalpak Kothari - kalpak@idearing.com
#################################

You are welcome to modify and distribute this code, but you MUST retain
this copyright notice above any notices you put.  If you use this program
beyond personal use, we request that you send us a copy of your modified code.

Napster is a registered trademark of Napster Inc - http://www.napster.com
******/

class Song {

  var $user= "";
  var $title= "";
  var $filename= "";
  var $checksum= "";
  var $size=0;
  var $bitrate=0;
  var $frequency=0;
  var $time=0;
  var $nick= "";
  var $nick_ip = "";
  var $conn_speed = 0;
  var $firewall = 0;


  function init_song($str, $type){
    if($type) {  // type == 1 => browse response packet
      list($this->nick, $title_noquotes, $info) = explode('"', $str);
      $this->title = '"' . $title_noquotes . '"';

      $info = substr($info, 1);
      list($this->checksum, $this->size, $this->bitrate, $this->frequency, $this->time) = explode(" ", $info);
    
      $temp = strrchr($this->title, '\\');
      if (!$temp)
	$this->filename = $this->title;
      else
	$this->filename = substr($temp, 1, strlen($temp)-2);

      //      $this->time = (int)(((int)$this->time)/60) . ":" . sprintf("%02d", ((int)$this->time)%60);

      $this->frequency /= 1000;
    }
    else {
      //first, get the pathname of the song
      for ($i=(strlen($str)-1);$i>=0 && strcmp($str[$i], '"')!=0;$i--);
      $this->title = substr($str,0,$i+1);

      $info = substr($str, $i+2);
      list($this->checksum, $this->size, $this->bitrate, $this->frequency, $this->time, $this->nick, $this->nick_ip, $this->conn_speed) = explode(" ", $info);
    
      //now get song name
      $temp = strrchr($this->title, '\\');
      if (!$temp)
	$this->filename = $this->title;
      else
	$this->filename = substr($temp, 1, strlen($temp)-2);

      //      $this->time = (int)(((int)$this->time)/60) . ":" . sprintf("%02d", ((int)$this->time)%60);

      $this->frequency /= 1000;

    }
  }

  function print_song($type) {
    global $server_socket, $napserver, $username, $password, $keywords,
      $FORMPOST, $conn_speed, $linespeed, $linktype, 
      $max, $nofirewall, $bdlynx;
 
    $title = urlencode($this->title);
    $nick = urlencode($this->nick);
    $filenamestr = str_replace(" ", "_", $this->filename);

    switch($type) {
    case 0: 
      $col0 = print_speed($this->conn_speed);
      $col1 = $this->print_time();
      $col2 = $this->print_size();
      $col3 = "$this->bitrate kbps";
      $col4 = "$this->frequency kHz";
      break;
    case 1: 
      $col2 = print_speed($this->conn_speed);
      $col1 = $this->print_time();
      $col0 = $this->print_size();
      $col3 = "$this->bitrate kbps";
      $col4 = "$this->frequency kHz";
      break;
    case 2: 
      $col1 = print_speed($this->conn_speed);
      $col0 = $this->print_time();
      $col2 = $this->print_size();
      $col3 = "$this->bitrate kbps";
      $col4 = "$this->frequency kHz";
      break;
    case 3: 
      $col3 = print_speed($this->conn_speed);
      $col1 = $this->print_time();
      $col2 = $this->print_size();
      $col0 = "$this->bitrate kbps";
      $col4 = "$this->frequency kHz";
      break;
    case 4: 
      $col4 = print_speed($this->conn_speed);
      $col1 = $this->print_time();
      $col2 = $this->print_size();
      $col3 = "$this->bitrate kbps";
      $col0 = "$this->frequency kHz";
      break;
    default:
      $col0 = print_speed($this->conn_speed);
      $col1 = $this->print_time();
      $col2 = $this->print_size();
      $col3 = "$this->bitrate kbps";
      $col4 = "$this->frequency kHz";
      break;
    }
    
    if($FORMPOST) {
      print("<td width=\"30\" valign=top><form method=POST action=\"download.php\">" .
	    "<input type=hidden name=napserver value=\"$napserver\">" .
	    "<input type=hidden name=username value=\"$username\">" .
	    "<input type=hidden name=password value=\"$password\">" .
	    "<input type=hidden name=title value=\"$title\">" .
	    "<input type=hidden name=nick value=\"$nick\">" .
	    "<input type=submit class=\"download\" value=\"Get\">" .
	    "</td>\n");
    }

    //    $rurl = urlencode("http://www.idearing.com/webnap/webnap-current/download.php/$this->filename?napserver=$napserver&username=$username&password=$password&nick=$nick&title=$title&affil=1");

    $rurl3= "queue.php?queue=1&napserver=$napserver&username=$username&password=$password&nick=$nick&title=$title&mpsize=$this->size";
    $idrive = $rurl3 . "&affil=1";
    $myplay = $rurl3 . "&affil=2";
    $freedrive = $rurl3 . "&affil=3";
    
    print ("<td valign=center width=\"400\" class=\"song\">");
    if($FORMPOST)
      print("</form>");
    
    print("<a href=\"download.php");
    if($bdlynx)
      print("/$filenamestr");
    print("?napserver=$napserver&username=$username&password=$password&nick=$nick&title=$title\">".
	  shorten($this->filename) . "</a>" .
    
	  "\n<br><a class=\"drive\" href=\"$myplay\">[myplay]</a>&nbsp;".
	  "<A HREF=\"$idrive\" class=\"drive\">[i-drive]</A>&nbsp;".
	  "<A HREF=\"$freedrive\" class=\"drive\">[freedrive]</A>&nbsp;".
	  //	  "<A HREF=\"JAVASCRIPT:xd_skip('$rurl')\" class=\"drive\">[xdrive]</A>".
	  "</td>\n");

    print("<td class=\"col0\" valign=center width=\"75\" align=center>" . 
	  $col0 . "</td>\n");

    print("<td valign=center width=\"120\"><table width=120 border=0 cellpadding=1 cellspacing=2><tr>\n".
	  "<td width=60 class=\"small1\" align=\"left\">$col1</td>".
	  "<td width=60 class=\"small2\" align=\"right\">$col2</td>".
	  "<tr><td width=60 class=\"small3\" align=\"left\">$col3</td>".
	  "<td width=60 class=\"small4\" align=\"right\">$col4</td></tr></table>\n".
	  "</td>\n");
    
    print("<td class=\"nick\" valign=center width=\"150\">");
    
    if ($this->firewall)
      print("<font color=red><a class=\"firewall\" href=\"searchmp3.php?napserver=$napserver&username=$username&password=$password&nick=$this->nick&conn_speed=$this->conn_speed&linespeed=$linespeed&linktype=$linktype&max=$max&nofirewall=$nofirewall&keywords=$keywords\">[$this->nick]</font></a></span></td>");
    else
      print("<a href=\"searchmp3.php?napserver=$napserver&username=$username&password=$password&nick=$this->nick&conn_speed=$this->conn_speed&linespeed=$linespeed&linktype=$linktype&max=$max&nofirewall=$nofirewall&keywords=$keywords\">$this->nick</a></td>");
  }
  
  function print_time() {
    return (int)(((int)$this->time)/60).":".sprintf("%02d", ((int)$this->time)%60);
  }

  function print_size() {
    return number_format($this->size);
  }
}

?>
